<?php
/*
**********************************************

         *** SmarterTrack Help Desk Module ***

This module ties together SmarterTrack and WHMCS in regards
to the support system.

**********************************************
*/
require_once('smartertrack_functions.php');
if (!defined("WHMCS"))
	die("This file cannot be accessed directly");

	
function smartertrack_config() {
    $configarray = array(
    "name" => "SmarterTrack Help Desk",
    "description" => "This is an open source addon module that works with SmarterTrack helpdesk to create an overall package within WHMCS",
    "version" => "1.0",
    "author" => "SmarterTools Inc.",
    "language" => "english",
    "fields" => array(
        "url" => array("FriendlyName" => "SmarterTrack Help Desk URL:", "Type" => "text", "Size" => "25", "Description" => "This URL MUST match the full URL to your SmarterTrack help desk. (E.g., https://support.domain.ext). HTTPS is recommended.", "Default" => "https://", ),
		
        "admin" => array("FriendlyName" => "Administrator Name:", "Type" => "text", "Size" => "25", "Description" => "The name of a SmarterTrack administrator. (E.g., admin or administrator)", ),
		
        "password" => array("FriendlyName" => "Administrator Password:", "Type" => "password", "Size" => "25", "Description" => "The password for the Administrator account above", ),
		
		"overridekb" =>  array("FriendlyName" => "Override default KB:", "Type" => "yesno", "Size" => "25",
        "Description" => "Checking this will change the knowledge base link to point to your SmarterTrack knowledge base instead of the default WHMCS KB.", ),
		
		"helpphone" => array("FriendlyName" => "Help Phone Number:", "Type" => "text", "Size" => "25", "Description" => "The phone number to display on error pages that your customers should call if they encounter issues.", ),
		
		"redirectcontact" =>  array("FriendlyName" => "Override Pre-Sales 'Contact Us'", "Type" => "yesno", "Size" => "25",
        "Description" => "Enabling this will not require a user to be logged in to send an inquiry email, but instead of an email, a ticket will be created in SmarterTrack", ),
		
		"contactdefaultdepartment" => array("FriendlyName" => "Default department name for 'Contact Us'", "Type" => "text", "Size" => "25", "Description" => "The Name of the Default Department you would like to use for sales inquiries.  EX:  'Sales Department'", ),
		
		"md5hashenabled" =>  array("FriendlyName" => "MD5 Hash Enabled?", "Type" => "yesno", "Size" => "25",
        "Description" => "This option should match the internal option of storing client passwords with a MD5 hash. This is an irreversible hash. With this unchecked, SmarterTrack will encrypt and decrypt passwords in sync with WHMCS so that users can use the same credentials to log in to both WHMCS and your SmarterTrack help desk. If it is checked, then users can only log into WHMCS. The module will continue to work but users will not be able to log into SmarterTrack separately from WHMCS as they won't know their passwords.",),

        "deptsToHide" => array("FriendlyName" => "Departments Hidden From Customers", "Type" => "text", "Size" => "25", "Description" => "List any departments that should not be visible to users, separated by commas", )
    ));
    return $configarray;
}

function smartertrack_activate() {

    # Create DB Table to link together WHMCS users with ST users
    $query = "CREATE TABLE IF NOT EXISTS `smartertrack_whmcs_users` (
      `id` int(11) NOT NULL AUTO_INCREMENT,
      `whm_userid` int(11) NOT NULL,
      `st_userid` int(11) NOT NULL,
	  `st_username` varchar(255) NOT NULL,
	  `st_password` varchar(255) NOT NULL,
	  `st_email` varchar(255) NOT NULL,
      UNIQUE KEY `id` (`id`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
	$result = mysql_query($query);
	

    # Return Result
    return array('status'=>'success','description'=>'SmarterTrack Module requires the url for the web services, an administrator agentname, and the administrators password, click configure to continue setup');
}

function smartertrack_deactivate() {

    # Remove Custom DB Table
    $query = "DROP TABLE `smartertrack_whmcs_users`";
	$result = mysql_query($query);

    # Return Result
    return array('status'=>'success','description'=>'SmarterTrack Module has been deactivated, thank you.');
}

function smartertrack_upgrade($vars) {
    
	$version = $vars['version'];

    # Run SQL Updates for V1.0 to V1.1
    //if ($version < 1.1) {

    # Run SQL Updates for V1.1 to V1.2
    //if ($version < 1.2) {
}

function smartertrack_output($vars) 
{
    $modulelink = $vars['modulelink'];
    $version = $vars['version'];
    $LANG = $vars['_lang'];

    echo '<p>'.$LANG['intro'].'</p>
	<p>'.$LANG['description'].'</p>
	<p>'.$LANG['documentation'].'</p>';
	
	$st_settings = smartertrack_settings();
	$st_ws_url = $st_settings['url']."/services2/svcOrganization.asmx?WSDL";
	$st_admin = $st_settings['admin'];
	$st_adminpassword = $st_settings['password'];
	
	if($_POST)
	{	
		$whmclients = select_query('tblclients', 'id, firstname, lastname, email, password', array());
		while ($data = mysql_fetch_array($whmclients))
		{
			//	Check our db table for existing entries with this client
			$client = smartertrack_getClient($data['id'], $st_settings);
			//if(!$client)
			//{
				$password = $data['password'];
				if($st_settings['md5hashenabled'] == false)
				{
					$password = decrypt($data['password']);
				}
			
				$params = array( "authUserName" => $st_admin,
					"authPassword" => $st_adminpassword,
					"username" => $data['email'],
					"password" => $password,
					"email" => $data['email'],
					"isEmailVerified" => true,
					"displayName" => $data['firstname']." ".$data['lastname']
				);

				$createuserreturn = smartertrack_webServiceCall($st_ws_url, $params, "CreateUser2");
				if($createuserreturn["CreateUser2Result"]["Result"] || ($createuserreturn["CreateUser2Result"]["Message"] == "Username is already in use" && !$client))
				{
                    $rtnUserId = $createuserreturn["CreateUser2Result"]["UserID"];

                    $paramsForEveryoneRole = array(
                        "authUserName" => $st_admin,
                        "authPassword" => $st_adminpassword,
                        "userID" => $rtnUserId,
                        "roleID" => 6
                    );

                    $paramsForRegisteredUserRole = array(
                        "authUserName" => $st_admin,
                        "authPassword" => $st_adminpassword,
                        "userID" => $rtnUserId,
                        "roleID" => 1
                    );

                    $st_ws_url = $st_settings['url']."/services2/svcOrganization.asmx?WSDL";
                    smartertrack_webServiceCall($st_ws_url,$paramsForEveryoneRole,"AddRoleToUser");
                    smartertrack_webServiceCall($st_ws_url,$paramsForRegisteredUserRole,"AddRoleToUser");

					$userid = "userid";
					$username = "username";
					//  Get the ID for the user now  // once we get new install up
					$propparamas = array( "authUserName"=> $st_admin,
									"authPassword"=> $st_adminpassword,
									"username" => $data['email'],
									"password" => $password,
									"requestedValues" => array( $userid, $username));

					$st_ws_url = $st_settings['url']."/services2/svcOrganization.asmx?WSDL";
					$returnprops = smartertrack_webServiceCall($st_ws_url, $propparamas, "GetUsersPropertiesbyUsername");

					if($returnprops["GetUsersPropertiesbyUsernameResult"]["Result"])
					{
						$equals = "=";
						foreach($returnprops["GetUsersPropertiesbyUsernameResult"]["RequestResults"]['string'] as $value)
						{
							$thekey = strstr($value, $equals, true);
							if($thekey === "userid")
							{
								$newstid = trim(strstr($value, $equals), $equals);
							}
							
						}
						if($st_settings['md5hashenabled'] == false)
						{
							$password = encrypt($password);
						}
						if($client)
						{
							// Update DB Table to Accomodate these new properties.
							//  update whmcs db
							$table = "smartertrack_whmcs_users";
							$update = array("st_password" => $password, "st_username" => $data['email'], "st_email" => $data['email'], "st_userid" => $newstid);
							$where = array("whm_userid" => $userid);
							update_query($table,$update,$where);
						}
						else
						{
							$table = "smartertrack_whmcs_users";
							$values = array("st_userid" => $newstid, "st_username" => $data['email'], 
									"st_password" => $password, "whm_userid" => $data['id'], 
									"st_email" => $data['email']);
							$queryresult = insert_query($table,$values);
						}
						echo "SUCCESS! Created <strong>".$data['firstname']." ".$data['lastname']."</strong> as a SmarterTrack User<br>";
						echo "<br>";
					}
					else
					{
						echo "A WHMCS user with the following email address already exists within SmarterTrack or failed during creation:  <strong>".$data['firstname']." ".$data['lastname']."</strong> Therefore, the user was not able to be created. To retry a fully sync, deactivate the SmarterTrack module then reactivate it, recreate your SmarterTrack settings and then try syncing again.  If the Problem persists, the user could have existed in SmarterTrack already with a different password.  If so, delete the user in SmarterTrack (or change password) and try again.";
						echo "<br>";
						if($returnprops["GetUsersPropertiesbyUsernameResult"]["Message"])
						{
							echo "The Error for this failure is ".$returnprops["GetUsersPropertiesbyUsernameResult"]["Message"];
						}
						echo "<br>";
					}
				}
				else
				{	
					
					echo "A WHMCS user with the following email address already exists within SmarterTrack or failed during creation:  <strong>".$data['firstname']." ".$data['lastname']."</strong>. Therefore, the user was not able to be created. To retry a full sync, deactivate the SmarterTrack module then reactivate it, recreate your SmarterTrack settings and then try syncing again.";
					echo "<br>";
					if($createuserreturn["CreateUserResult"]["Message"])
					{
						echo "The Error for this failure is: <strong>".$createuserreturn["CreateUserResult"]["Message"]."</strong>";
					}
					echo "<br><br>";
				}
			//}
			//else
			//{
			//	echo "<br>";
			//	echo "A WHMCS user with the following email address already exists within SmarterTrack:  <strong>".$data['firstname']." ".$data['lastname']."</strong> Therefore, the user was not able to be created. To retry a full sync, deactivate the SmarterTrack module then reactivate it, recreate your SmarterTrack settings and then try syncing again.";
			//	echo "<br>";
			//}
		}
	}
	$blah = select_query("smartertrack_whmcs_users", 'id, st_userid, st_email, st_username, st_password, whm_userid', array());
	echo "<br><br>";
	echo "<strong>The following WHMCS users are currently synced to SmarterTrack:</strong><br>";
	while ($data1 = mysql_fetch_array($blah))
	{
		print_r($data1['st_email']);
		echo "<br>";
	}
	echo "<br><br>";
	echo "Click to generate SmarterTrack Users for users in the WHMCS database and synchronize the two systems (duplicates will not be created):";
	echo "<form name='submitusers' method='post' enctype='multipart/form-data' id='submituser'>";
	echo "<input class='btn primary' type='submit' name='save' value='Generate' />";
	echo "</form>";
	

}

function smartertrack_sidebar($vars) {

    $modulelink = $vars['modulelink'];
    $version = $vars['version'];
    $LANG = $vars['_lang'];

    $sidebar = '<span class="header"><img src="../modules/addons/smartertrack/images/smartertrack.jpg" class="absmiddle" width="16" height="16" /> SmarterTrack Help Desk Module</span>
<ul class="menu">
        <li><a href="http://portal.smartertools.com">SmarterTools Inc (help / kbs)</a></li>
        <li><a href="http://portal.smartertools.com">Version: '.$version.'</a></li>
    </ul>';
    return $sidebar;

}

?>